#!/usr/bin/python

import csv

inputfile = './output/std_mergesort_speedup_data.csv'
if len(sys.argv) > 2:
    inputfile = sys.argv[1]
PDFoutput = './output/PDF_mergesort_speedup.csv'
WSoutput  = './output/WS_mergesort_speedup.csv'
if len(sys.argv) > 4:
    PDFoutput = sys.argv[2]
    WSoutput = sys.argv[3]

rownum = 0
reps = 0
threads = 0
runsize = 0
numruns = 0
numtasks = []
sortTime = [[],[]]
mergeTime = [[],[]]
totalTime = [[],[]]
seqSortTime=0

with open(inputfile,'rb') as infile:
    reader = csv.reader(infile)
    for row in reader:
        if rownum == 1:
            threads = int(row[1])
            runsize = int(row[2])
            numruns = int(row[3])
            reps = int(row[4])
        if rownum == 0:
            header = row
        elif row[0] == 'PDF':
            numthreads.append(int(row[4]))
            repMergeTime = 0
            repSortTime = 0
            repTotalTime = 0
            for rep in range(5,reps+4,2):
                repSortTime += float(row[rep])/reps
                repMergeTime += float(row[rep+1])/reps
                repTotalTime += (float(row[rep]) + float(row[rep+1]))/reps
            sortTime[0].append(repSortTime)
            mergeTime[0].append(repMergeTime)
            totalTime[0].append(repTotalTime)
        elif row[0] == 'WS':
            repMergeTime = 0
            repSortTime = 0
            repTotalTime = 0
            for rep in range(5,reps+4,2):
                repSortTime += float(row[rep])/reps
                repMergeTime += float(row[rep+1])/reps
                repTotalTime += (float(row[rep]) + float(row[rep+1]))/reps
            sortTime[1].append(repSortTime)
            mergeTime[1].append(repMergeTime)
            totalTime[1].append(repTotalTime)
        elif row[0] == 'SEQ':
            repsortTime=0
            for rep in range(5,reps+4):
                repsortTime += float(row[rep])/reps
                seqSortTime = repsortTime
        rownum += 1

#write plot data file
Rows = [['#Scheduler','threads','runsize','numruns','tasks','repetitions','avgsorttime', 'avgmergetime', 'avg totaltime','speedup']]
for run in range(0,len(numtasks)) :
    Rows.append(["PDF", threads, runsize, numruns, numtasks[run], reps, sortTime[0][run], sortTime[0][run], totalTime[0][run], seqSortTime/totalTime[0][run]])
with open(PDFoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
Rows = [['#Scheduler','threads','runsize','numruns','tasks','repetitions','avgsorttime', 'avgmergetime', 'avg totaltime','speedup']]
for run in range(0,len(numtasks)) :
    Rows.append(["WS", thread, runsize, numruns, numtasks[run], reps, sortTime[0][run], sortTime[0][run], totalTime[0][run], seqSortTime/totalTime[0][run]])
with open(WSoutput, 'wb') as f:
    writer = csv.writer(f)
    writer.writerows(Rows)
